 
#python DEEP.py <Test data>

# gensim modules
from gensim import utils
from gensim.models.doc2vec import TaggedDocument,LabeledSentence
from gensim.models import Doc2Vec

# numpy
import numpy as np

# classifier
from sklearn.ensemble import RandomForestClassifier
from sklearn.multiclass import OneVsRestClassifier
from sklearn.linear_model import LogisticRegression
from sklearn.cross_validation import train_test_split
from sklearn.ensemble import GradientBoostingClassifier
from sklearn import metrics
from sklearn.svm import SVC
from sklearn.externals import joblib

# utils
import random
import os
from os import listdir
import sys
import multiprocessing
import logging
logging.basicConfig(format='%(asctime)s : %(levelname)s : %(message)s', level=logging.INFO)


##########################################################
#							 #
#		Training the model 			 #
#							 #
##########################################################

#sources = {}

#For data used to train the model, you can add your own by replacing the files in the dir Deep_data
#Put positive examples in a text file called "1" and negative examples in a text file called "0" 
#for f in listdir("Deep_data"):
    #print f
#    if not sources.has_key(f):
#        sources["Deep_data/"+f]=f

#sentences = LabeledLineSentence(sources)

#model = Doc2Vec(min_count = 4, window = 3, size = 20, dm = 2, sample = 1e-3, negative = 0, workers = 7)
#model.build_vocab(sentences.to_array())

#for epoch in range(1000):
#    print(epoch)
#    model.train(sentences.sentences_perm())

###################################################
#						  #
#		Prediction section	          #
#						  #
###################################################
def funcMain(proteinNum):
	print(proteinNum[0])
	#exit(1)
        	
	#Generates a prediction for the protein based on classifer results
	def get_prot_label_result(X,classifier,filename):   
		fout = open(filename,"w")
		prot_predicted_label = {}
		predicted = classifier.predict(X)
	    
		#probs = classifier.predict_proba(X)
		for i in range(len(X)):
			x = X[i]
			x_str = " ".join([str(j) for j in x])
			text = org_feature_to_text[x_str]
			#text = bow_to_text[bow_str]
			prots = org_text_to_prot[text]
			text_label = predicted[i]
			for prot in prots:
			    
				if not prot_predicted_label.has_key(prot):
					prot_predicted_label[prot] = []
					prot_predicted_label[prot].append(text_label)
				else:
					prot_predicted_label[prot].append(text_label) 
	    
		for prot in prot_predicted_label:	
			MP_count = sum(prot_predicted_label[prot])
		#        if MP_count >= len(prot_predicted_label[prot])-MP_count:	#for 50% majority vote	
			if MP_count > len(prot_predicted_label[prot]) * 0.8:
				fout.write(prot+" 1\n")
			else:
				fout.write(prot+" 0\n")

	class LabeledLineSentence(object):
		def __init__(self, sources):
			self.sources = sources

			flipped = {}

			# make sure that keys are unique
			for key, value in sources.items():
				if value not in flipped:
					flipped[value] = [key]
				else:
					raise Exception('Non-unique prefix encountered')

		def __iter__(self):
			for source, prefix in self.sources.items():
				with utils.smart_open(source) as fin:
					for item_no, line in enumerate(fin):
			    			yield TaggedDocument(utils.to_unicode(line).split(), [prefix + '_%s' % item_no])

		def to_array(self):
			self.sentences = []
			for source, prefix in self.sources.items():
		    		with utils.smart_open(source) as fin:
					for item_no, line in enumerate(fin):
			    			self.sentences.append(TaggedDocument(utils.to_unicode(line).split(), [prefix + '_%s' % item_no]))
			return self.sentences
		def sentences_perm(self):
			random.shuffle(self.sentences)
			return self.sentences




	#Loops through input protein list and makes a prediction
	for inp in proteinNum:
		#Uses pretrained model for performance improvement
		model = Doc2Vec.load("Deep_Model")
		print ("Done Model Training")

		#Builds test set with labels
		Xtest = []
		organism_data = open(inp,"r")
		org_text_to_prot = {}
		org_feature_to_text = {}
		org_texts = []
		while 1:
		    line = organism_data.readline()
		    if not line:
			break
		    (id,text) = line.strip().split("\t")
		    if not org_text_to_prot.has_key(text):
			org_text_to_prot[text] = set()
			org_text_to_prot[text].add(id)
			
			l = utils.to_unicode(text).split()
			x =  model.infer_vector(l)
			Xtest.append(x)
			
			x_str = " ".join([str(j) for j in x])
			org_feature_to_text[x_str]=text
			#texts.append(text.split())
		    else:
			org_text_to_prot[text].add(id)
		    
		
		#Builds training set with labels
		#DISABLED CURRENTLY FOR PERFORMANCE 
		X = []
		y = []
		#UNCOMMENT IF YOU WISH TO RETRAIN CLASSIFIERS
		#MP_file = open("abstracts_MP.dat","r")
		text_to_prot = {}
		text_to_label = {}
		feature_to_text = {}
		texts = []
		#CHANGE 0 to 1 IF YOU WISH TO RETRAIN CLASSIFIERS
		while 0:
		    line = MP_file.readline()
		    if not line:
			break
		    (id,text) = line.strip().split("\t")
		    if not text_to_prot.has_key(text):
			text_to_prot[text] = set()
			text_to_prot[text].add(id)
			text_to_label[text]=1
			l = utils.to_unicode(text).split()
			x =  model.infer_vector(l)
			X.append(x)
			y.append(1)
			x_str = " ".join([str(j) for j in x])
			feature_to_text[x_str]=text
		    else:
			text_to_prot[text].add(id)

		

		#UNCOMMENT IF RETRAINING CLASSIFIERS AND CHANGE 0 to 1
		#NonMP_file = open("abstracts_NMP.dat","r")
		while 0:
		    line = NonMP_file.readline()
		    if not line:
			break
		    (id,text) = line.strip().split("\t")
		    if not text_to_prot.has_key(text):
			text_to_prot[text] = set()
			text_to_prot[text].add(id)
			text_to_label[text]=0
			l = utils.to_unicode(text).split()
			x =  model.infer_vector(l)
			X.append(x)
			y.append(0)
			x_str = " ".join([str(j) for j in x])
			feature_to_text[x_str]=text
		    else:
			text_to_prot[text].add(id)

		print ("Done feature generation using deep model")
		
		#UNCOMMENT THE FIRST TWO LINES FOR EACH CLASSIFIER BLOCK TO RETRAIN
		#COMMENT the joblib.load line as well if retraining


		#classifier =  LogisticRegression(C = 0.5, solver = 'liblinear', max_iter = 100)
		#classifier.fit(X, y)
		classifier = joblib.load( "lr.pkl")
		get_prot_label_result(Xtest,classifier,'DEEP_logistic_'+inp)
		#joblib.dump(classifier, "lr.pkl")

		#classifier = RandomForestClassifier(n_estimators = 750)
		#classifier.fit(X, y)
		#joblib.dump(classifier, "rf.pkl")
		classifier = joblib.load( "rf.pkl")
		get_prot_label_result(Xtest,classifier,'DEEP_randomforest_'+inp)  

		#classifier = GradientBoostingClassifier(learning_rate=0.2, n_estimators = 250)
		#classifier.fit(X, y)
		#joblib.dump(classifier, "gb.pkl")
		classifier = joblib.load("gb.pkl")
		get_prot_label_result(Xtest,classifier,'DEEP_gradientboost_'+inp) 

		#classifier = SVC(kernel = 'rbf', C = 7, gamma = 0.01)
		#classifier.fit(X, y)
		#joblib.dump(classifier, "SVM.pkl")
		classifier = joblib.load("SVM.pkl")
		get_prot_label_result(Xtest,classifier,'DEEP_SVM_'+inp) 

		print ("Done prediction on new test data")

#Chunks the input protein list into N evenly populated lists for multithreading
def chunks(seq, num):
    avg = len(seq) / float(num)
    out = []
    last = 0.0

    while last < len(seq):
        out.append(seq[int(last):int(last + avg)])
        last += avg

    return out
def stuff(inpf):
	for i in inpf:
		print i
dataList = list()
#Please assign the value for the following variable to your data directory
inpDir = "data/"
#Constructs list of test data
for root, dirs, files in os.walk(inpDir, topdown=False):
	for name in files:
		dataList.append(os.path.join(root, name))
#print len(dataList)

#Chunks data, change procNum to the amount of processes you wish to run(I would recommend YOUR_CORE_COUNT - 3)
procNum = 10
outl = chunks(dataList, procNum)
#print outl[0]


#Creates a process for each list 
procList = list()
for i in xrange(len(outl)):
	p = multiprocessing.Process(target=funcMain, args=(outl[i], ))
	procList.append(p)
	p.start()

#Waits for procs to finish running
for proc in procList:
	proc.join()

print("ALL DONE")
