'''
Author: Md Mansurul Bhuiyan
Email: mansurul1985@gmail.com
Date Created: April 2016
'''

from lxml.html import parse
from urllib2 import urlopen
from pandas.io.parsers import TextParser
import time
import random
import sys
import multiprocessing

def _unpack (row,kind='td'):
    elts = row.findall('.//%s' % kind)
    return [val.text for val in elts]

def parse_options_data (table):
    rows = table.findall('.//tr')
    header = _unpack(rows[0],kind='th')
    data = [_unpack(r) for r in rows[1:]]
    return TextParser(data,names=header).get_chunk()

def grabData(inpList, queue, queue2):
  #  abstract_link = open(sys.argv[1],"r")
  #  abstract = open("abstracts.out","a")
  #  title = open("Titles.out","a")
    count = 1
    flag = False
    for inp in inpList:
        #if(flag):
        #        flag = False
        #        for x in xrange(0):
        #                abstract_link.readline()
	abstract_link = inp
        if(inp == "https://www.uniprot.org/citations/10617197"):
		continue
	url = abstract_link
        if not url:
            break
        url = url.strip().split(" ")
        print url
        prot = url[0]
        url = url[1]
        #url = 'http://www.uniprot.org/uniprot/'+prot #Q14565'
        parsed = None
        try:
                parsed = parse(url)
        except:
                print "failed to load resource"
                print url
                continue

        doc = parsed.getroot()
        titles = doc.findall('.//h3')
        for t in titles:
            classes = t.values()
            #print items, t.values()
            if len(classes)>=2 and classes[1]=='noline':
                #print t.text_content(), len(titles), t.items()
                queue2.put(prot+"\t"+t.text_content().encode('utf-8')+"\n")
        text = doc.findall('.//p')
        for p in text:
            values = p.values()
            if values and values[0]=="schema:description":
                queue.put(prot+"\t"+p.text_content().encode('utf-8')+"\n")

def chunks(seq, num):
	avg = len(seq) / float(num)
	out = []
	last = 0.0

	while last < len(seq):
		out.append(seq[int(last):int(last + avg)])
		last += avg

	return out
def stuff(inpf):
	for i in inpf:
		print i

def writer2(writeQueue):
	title = open("Title.out", "a")
	while True:
		line = writeQueue.get()
		if line == "STOP":
			return
		title.write(line)

def writer(writeQueue):
        abstract_links = open("abstract.out","a")
        while True:
                line = writeQueue.get()
                if line == "STOP":
                        return
                abstract_links.write(line)


if __name__ == '__main__':

        with open("abstract_new.out") as f:
                dataList = f.readlines()
        outl = chunks(dataList, 3)
        print ("FINISHED CHUNKING LISTS FOR EACH PROC")
        #print outl[0]
        procList = list()
        queue = multiprocessing.Queue()
	queue2 = multiprocessing.Queue()
        writer_process = multiprocessing.Process(target = writer, args=(queue, ))
        writer2_proc = multiprocessing.Process(target = writer2, args=(queue2, ))
	writer_process.start()
	writer2_proc.start()

        for i in xrange(len(outl)):
                p = multiprocessing.Process(target=grabData, args=(outl[i], queue, queue2))
                procList.append(p)
                p.start()
        print("FINISHED STARTING ALL PROCS")
        for proc in procList:
                proc.join()

        queue.put("STOP")
	queue2.put("STOP")
        writer_process.join()
	writer2_proc.join()

 
