'''
Author: Md Mansurul Bhuiyan
Email: mansurul1985@gmail.com
Date Created: April 2016
'''
from Queue import *
from lxml.html import parse
from urllib2 import urlopen
from pandas.io.parsers import TextParser
import time
import random
import sys
import multiprocessing

def _unpack (row,kind='td'):
   	elts = row.findall('.//%s' % kind)
    	return [val.text for val in elts]

def parse_options_data (table):
	rows = table.findall('.//tr')
    	header = _unpack(rows[0],kind='th')
    	data = [_unpack(r) for r in rows[1:]]
    	return TextParser(data,names=header).get_chunk()


def mainStuff(inpList, queue):
	    
    	# protein_names = open("Dros_list","r")

    	# flag = True
    	for prot in inpList:
		# if (flag):
		# 	flag = False
		# 	for i in xrange(702):
        	# 		protein_names.readline()
	        # prot = protein_names.readline()
		if '-' in prot:
        	    tmpprot = prot.split("-")
		    prot = tmpprot[0]
	        prot = prot.strip()
        	url = 'http://www.uniprot.org/uniprot/'+prot+"/publications" #Q14565'
	        print (url)
	        try:
			parsed = parse(url)
		except:
			continue
        	doc = parsed.getroot()
	        citations = doc.findall('.//ol')
        	#if citations:
        #    citations = citations
	        for cite in citations:
        	    t = cite.findall('.//a')
	            #print len(t)
        	    for t1 in t:
	                link = t1.get('href')
        	        if link:
                	    l = link.strip().split("/")
                    #print l,prot
	                    if len(l) >=3 and l[1]=="citations":
        	                abstract = "http://www.uniprot.org/citations/"+l[2] #8590282
                	    #print prot, abstract
                        	#abstrList.append(abstract)
				queue.put(prot+" "+abstract+"\n")
        #sleep = random.randint(10, 15)
        #time.sleep(sleep)
def chunks(seq, num):
    avg = len(seq) / float(num)
    out = []
    last = 0.0

    while last < len(seq):
        out.append(seq[int(last):int(last + avg)])
        last += avg

    return out
def stuff(inpf):
        for i in inpf:
                print i
def writer(writeQueue):	
    	# abstrSet = set(abstrList)
	abstract_links = open("abstract_links_list.out","a")
	while True:
				
		line = writeQueue.get()
		#checkList = line.split(" ")
		
		#print(checkList[1])
		#if(abstrList.count(checkList[1]) > 7):
		#	continue
			
		if line == "STOP":
			return
		abstract_links.write(line)	

if __name__ == "__main__":
        #for name in :
        #        dataList.append(os.path.join(root, name))
	with open("IDlist") as f:
		dataList = f.readlines()
	outl = chunks(dataList, 3)
	procList = list()
	print ("FINISHED CHUNKING LISTS FOR EACH PROC")
	#print outl[0]
	queue = multiprocessing.Queue()
	
	writer_process = multiprocessing.Process(target=writer, args=(queue, ))
	writer_process.start()
	
	for i in xrange(len(outl)):
		p = multiprocessing.Process(target=mainStuff, args=(outl[i], queue))
		procList.append(p)
		p.start()
	# mainStuff(dataList, queue, abstrList)
	print("FINISHED STARTING ALL PROCS")
	for proc in procList:
		proc.join()
	
	queue.put("STOP")

	print("WRITING BUFFER")

	#writer(queue, abstrList)
	writer_process.join()
	#writer(queue, abstrList)
	# writer_process.join()
